package com.hai.dao;

import com.hai.entity.HighActivityAwardActualPrize;
import com.hai.entity.HighActivityAwardActualPrizeExample.Criteria;
import com.hai.entity.HighActivityAwardActualPrizeExample.Criterion;
import com.hai.entity.HighActivityAwardActualPrizeExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighActivityAwardActualPrizeSqlProvider {

    public String countByExample(HighActivityAwardActualPrizeExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_activity_award_actual_prize");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighActivityAwardActualPrizeExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_activity_award_actual_prize");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighActivityAwardActualPrize record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_activity_award_actual_prize");
        
        if (record.getActivityAwardPrizeId() != null) {
            sql.VALUES("activity_award_prize_id", "#{activityAwardPrizeId,jdbcType=BIGINT}");
        }
        
        if (record.getActivityAwardSerialNumId() != null) {
            sql.VALUES("activity_award_serial_num_id", "#{activityAwardSerialNumId,jdbcType=BIGINT}");
        }
        
        if (record.getActualPrizeType() != null) {
            sql.VALUES("actual_prize_type", "#{actualPrizeType,jdbcType=INTEGER}");
        }
        
        if (record.getActualPrizeId() != null) {
            sql.VALUES("actual_prize_id", "#{actualPrizeId,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighActivityAwardActualPrizeExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("activity_award_prize_id");
        sql.SELECT("activity_award_serial_num_id");
        sql.SELECT("actual_prize_type");
        sql.SELECT("actual_prize_id");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_activity_award_actual_prize");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighActivityAwardActualPrize record = (HighActivityAwardActualPrize) parameter.get("record");
        HighActivityAwardActualPrizeExample example = (HighActivityAwardActualPrizeExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_activity_award_actual_prize");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getActivityAwardPrizeId() != null) {
            sql.SET("activity_award_prize_id = #{record.activityAwardPrizeId,jdbcType=BIGINT}");
        }
        
        if (record.getActivityAwardSerialNumId() != null) {
            sql.SET("activity_award_serial_num_id = #{record.activityAwardSerialNumId,jdbcType=BIGINT}");
        }
        
        if (record.getActualPrizeType() != null) {
            sql.SET("actual_prize_type = #{record.actualPrizeType,jdbcType=INTEGER}");
        }
        
        if (record.getActualPrizeId() != null) {
            sql.SET("actual_prize_id = #{record.actualPrizeId,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_activity_award_actual_prize");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("activity_award_prize_id = #{record.activityAwardPrizeId,jdbcType=BIGINT}");
        sql.SET("activity_award_serial_num_id = #{record.activityAwardSerialNumId,jdbcType=BIGINT}");
        sql.SET("actual_prize_type = #{record.actualPrizeType,jdbcType=INTEGER}");
        sql.SET("actual_prize_id = #{record.actualPrizeId,jdbcType=BIGINT}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighActivityAwardActualPrizeExample example = (HighActivityAwardActualPrizeExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighActivityAwardActualPrize record) {
        SQL sql = new SQL();
        sql.UPDATE("high_activity_award_actual_prize");
        
        if (record.getActivityAwardPrizeId() != null) {
            sql.SET("activity_award_prize_id = #{activityAwardPrizeId,jdbcType=BIGINT}");
        }
        
        if (record.getActivityAwardSerialNumId() != null) {
            sql.SET("activity_award_serial_num_id = #{activityAwardSerialNumId,jdbcType=BIGINT}");
        }
        
        if (record.getActualPrizeType() != null) {
            sql.SET("actual_prize_type = #{actualPrizeType,jdbcType=INTEGER}");
        }
        
        if (record.getActualPrizeId() != null) {
            sql.SET("actual_prize_id = #{actualPrizeId,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighActivityAwardActualPrizeExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}